#!/bin/bash
#
# File: /usr/local/bin/specialcharfilerename-german
#
# change filenames they have german special characters to names they have
# only us-ascii characters, or names they have only us-ascii characters to
# names they have german special characters
#
#    Copyright (C) 2013 Ingo Kaesmann
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Script template: 0.3.0
#
# Exit codes:
# 0 = OK
# 1 = Error in parameters
# 2 = Error in configfile, configfile old or not found
# 3 = Library old or not found
# 8 = Error in other file or other file not found
# 10= no file for changing
# 99= Other error
##############################################################################
# SOURCE FILES

. /usr/local/etc/main-inka-sh.conf			# main config
. $LLIBDIR/lib-inka-std.sh				# functions standard
test -e /usr/local/etc/chchar-german.conf && . /usr/local/etc/chchar-german.conf	# global config of chchar-german
##############################################################################
# DECLARATION OF VARIABLES

# STRINGS
pkgname=inka-utilities					# package name for work
lib_inka_std_sh_needed=1.3.6				# standard lib version
conf_file_needed=0.2.0					# conf file version
#----------------------- end of variables to configure -----------------------
version=$(grep "^VERSION" $PROGREG/$pkgname.inf | cut -f 2)	# version
scriptname=$(basename $0)				# name of script
tempfile=$TEMPDIR/$scriptname.$UID.$$.tmp		# temporary file
infolog="logger -p user.info -t $scriptname --"		# log info messages
errlog="logger -p user.err -t $scriptname -- ERROR:"	# log error messages
debuglog="logger -p user.debug -t $scriptname -- DEBUG:" # log debug messages
debug=no						# debug=yes/no
verbose=""						# verbose=""/-q/-v
opt_found=no						# opt_found=yes/no
opt=""							# option
#------------------------- end of standard variables -------------------------
list1=$TEMPDIR/$scriptname.$UID.1.tmp			# list 1
list2=$TEMPDIR/$scriptname.$UID.2.tmp			# list 2
opt_n=""						# opt_n=""/-n
SpecialCharFileRename_German_Conf=$ChChar_German_Conf	# used for version check

# NUMBERS
err=0							# exit code
##############################################################################
# FUNCTIONS

function show_help ()
{
# Show help
# Uses: cat
# Return codes: standard

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG show_help: $# $@" >&2
	#$debuglog show_help: $# $@
fi

cat <<EOT

Aufruf: $scriptname OPTION...
Deutsche Sonderzeichen in allen Dateinamen des aktuellen Verzeichnisses nach
einer manuellen Kontrolle gegen us-ascii-Zeichen tauschen (bzw. umgekehrt)

        -g      us-ascii-Zeichen gegen deutsche Sonderzeichen tauschen
        -u      deutsche Sonderzeichen gegen us-ascii-Zeichen tauschen
        -n      ohne Kontrolle und Bearbeitung der neuen Dateinamen
-h, --help      Hilfe anzeigen und beenden
 --version      Versionsinformationen anzeigen und beenden
--show-config      Programmkonfiguration anzeigen und beenden
   --debug      Debug-Modus benutzen
        -q      ohne Meldungen
        -v      mit vielen Meldungen

Verzeichnisse werden nicht umbenannt.
Wenn beim Bearbeiten der neuen Dateinamen im Editor die Anzahl der Zeilen
veraendert wird, werden keine Dateien umbenannt!
EOT
return 0
}
#-----------------------------------------------------------------------------
function show_config ()
{
# Show configuration of program
# Uses: cat, cut, grep
# Return codes: standard

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG show_config: $# $@" >&2
	#$debuglog show_config: $# $@
fi

cat <<EOT

Deutsche Umlaute muessen in folgenden Zeilen lesbar sein:
Ae   = $UmlAe
Oe   = $UmlOe
Ue   = $UmlUe
ae   = $Umlae
oe   = $Umloe
ue   = $Umlue
ss   = $Umlss
EURO = $UmlEURO

EOT

return 0
}
#-----------------------------------------------------------------------------
function us_ascii_german ()
{
# Change us-ascii character (Ae, Oe, Ue, ae, oe, ue) filenames to german
# special character filenames
# Show and serve for edit the new named filenames and filenames they have
# AE, OE, UE, ss, EURO in name, if not -n given
# Uses: echo, grep, rm, chchar-german, lib-inka-std.sh
# Return codes: 0 = ok, 10 = no files for changing, 99 = failur by renaming

local string="" err=0 ret=0

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG us-ascii_deutsch: $# $@" >&2
	#$debuglog us-ascii_deutsch: $# $@
fi

/bin/ls -1p | grep "AE\|Ae\|OE\|Oe\|UE\|Ue\|ae\|oe\|ue\|ss\|EURO" | grep -v "/" > $list1  # build list of rename-files
if [ -s $list1 ]; then				# files found
	chchar-german -s $list1 > $list2	# build list of new file names
	if [ -z "$opt_n" ]; then		# opt -n not given - editoring filenames wished
		if [ "$verbose" == "-v" ]; then
			echo "Neue Dateinamen kontrollieren und ggf. aendern."
			echo "Zum Abbrechen der Ausfuehrung eine Zeile loeschen."
			echo ""
			echo "Weiter mit Enter-Taste zum Bearbeiten der Dateinamen."
			read string
		fi
		$EDITOR $list2	# control of new file names, if not -n given
	fi
	Move_By_Listings $list1 $list2			# change file names
	ret=$?
	if [ $ret -ne 0 ]; then			# count of filenames changed
		if [ "$verbose" != "-q" ]; then
			echo "Fehler - Anzahl neuer Dateinamen falsch! Keine Dateien umbenannt." >&2
		else
			$errlog wrong filename count
		fi
		err=99
	fi
else
	if [ "$verbose" == "-v" ]; then
		echo "Keine Dateien umzubenennen."
	fi
	err=10
fi

rm -f $tempfile $list1 $list2
return $err
}
#-----------------------------------------------------------------------------
function german_us_ascii ()
{
# Change german special character and euro-sign filenames to us-ascii character
# (Ae, Oe, Ue, ae, oe, ue, ss, EURO) filenames
# Show and serve for edit the new named filenames and filenames
# Uses: echo, grep, rm, chchar-german, lib-inka-std.sh
# Return codes: 0 = ok, 10 = no files for changing, 99 = failur by renaming

local string="" err=0 ret=0

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG deutsch_us-ascii: $# $@" >&2
	$debuglog deutsch_us-ascii: $# $@
fi

/bin/ls -1p | grep "$UmlAe\|$UmlOe\|$UmlUe\|$Umlae\|$Umloe\|$Umlue\|$Umlss\|$UmlEURO" | grep -v "/" > $list1  # build list of rename-files
if [ -s $list1 ]; then				# files found
	chchar-german -u $list1 > $list2	# build list of new file names
	if [ -z "$opt_n" ]; then		# opt -n not given - editoring filenames wished
		if [ "$verbose" == "-v" ]; then
			echo "Neue Dateinamen kontrollieren und ggf. aendern."
			echo "Zum Abbrechen der Ausfuehrung eine Zeile loeschen."
			echo ""
			echo "Weiter mit Enter-Taste zum Bearbeiten der Dateinamen."
			read string
		fi
		$EDITOR $list2	# control of new file names, if not -n given
	fi
	Move_By_Listings $list1 $list2			# change file names
	ret=$?
	if [ $ret -ne 0 ]; then			# count of filenames changed
		if [ "$verbose" != "-q" ]; then
			echo "Fehler - Anzahl neuer Dateinamen falsch! Keine Dateien umbenannt." >&2
		else
			$errlog wrong filename count
		fi
		err=99
	fi
else
	if [ "$verbose" == "-v" ]; then
		echo "Keine Dateien umzubenennen."
	fi
	err=10
fi

rm -f $tempfile $list1 $list2
return $err
}
##############################################################################
# PARSE COMMANDLINE

# Read all options with args and all additional args into variables.
# Stop parsing after last parameter.
# Try to do a check on all parameters and version numbers.
# Handle options -h, --show-config and --version directly.
# Exit on error.

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG Parse Commandline: $# $@" >&2
	#$debuglog Parse Commandline: $# $@
fi

# get options and options with arguments
while [ "${1:0:1}" == "-" ]; do				# get all options
	case "$1" in
	  -h|--help)	opt=-h;;			# option -h
	  --version)	opt=--v;; 			# option --version
	  --show-config) opt=--s;;			# option --show-config
	  --debug)	debug=yes;;			# option --debug
	  -q|--quiet)	verbose=-q;;			# option -q
	  -v|--verbose)	verbose=-v;;			# option -v
#-------------------------- end of standard options --------------------------
	  -g|-u)	opt="$1";;			# option -g, -u
	  -n)		opt_n=-n;;			# option -n
	  *)	if [ "$verbose" != "-q" ]; then
			echo "Fehler - Option $1 falsch!" >&2	# error
		else
			$errlog unknown option $1
		fi
		exit 1;;
	esac
	shift
	opt_found=yes
done

# handle standard options -h, --v, --s
case "$opt" in
  -h)	show_help; exit 0;;					# show help
  --v)	echo "$scriptname (${pkgname}) $version"; exit 0;;	# show version
  --s)	show_config; exit 0;;					# show config
esac

# check library
Compare_Version $lib_inka_std_sh_needed $Lib_Inka_Std_Sh_Version
ret=$?						# (ret: 0,1,2,9,127)
if [ $ret -eq 1 ]; then				# needed lib-version higher than installed
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - Programm benoetigt neuere Version von lib-inka-std.sh!" >&2
	else
		$errlog newer version of lib-inka-std.sh needed
	fi
	exit 3
elif [ $ret -eq 9 ] || [ $ret -eq 127 ]; then	# other error (version or lib missing)
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - Versionspruefung von lib-inka-std.sh nicht moeglich!"
	else
		$errlog check of version of lib-inka-std.sh impossible
	fi
	exit 3
else						# check ok, reset $ret
	ret=0
fi

# check version of config files			# set config var!
Compare_Version $conf_file_needed $SpecialCharFileRename_German_Conf
#Compare_Version $conf_file_needed $Program_Rc
ret=$?						# (ret: 0,1,2,9)
if [ $ret -eq 1 ]; then				# needed config-version higher than installed
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - $scriptname benoetigt neuere Version der Konfig-datei!" >&2
	else
		$errlog newer version of conf file needed
	fi
	exit 2
elif [ $ret -eq 9 ]; then			# other error (version of conffile missing)
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - Versionspruefung der Konfig-datei von $scriptname nicht moeglich!"
	else
		$errlog check of version of conf file impossible
	fi
	exit 2
else						# check ok, reset $ret
	ret=0
fi

# check arguments after options
case "$opt" in
  *)	if [ "$#" -ne 0 ]; then			# error in param count
		if [ "$verbose" != "-q" ]; then
			echo "Fehler - Parameteranzahl falsch!" >&2
		else
			$errlog parameter count
		fi
		exit 1
	fi;;
esac

##############################################################################
# MAINPROGRAM

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG Main: $# $@" >&2
	#$debuglog Main: $# $@
fi

# Check what to do (initial options and args are removed from cmdline)
case "$opt" in
  -g)							# opt -g
	us_ascii_german
	err=$?;;
  -u)							# opt -u
	german_us_ascii
	err=$?;;
  "")							# no opt given
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - Option fehlt!" >&2
	else
		$errlog option missing
	fi
	err=1;;
esac

exit $err
